Unit SFile;
Interface
  Uses CRT,Graph;
  Type  ScoreType   = record
          Name  : string;
          Score : integer;
        end;
        ScoreFType = array [1..10] of ScoreType;
  Const ScoreFName = 'global.res';
        NameLength = 9;
        DefaultScores : ScoreFType =
       ((Name:'Ilya     ';Score:19999),
        (Name:'Silvester';Score: 9000),
        (Name:'Van Damme';Score: 8000),
        (Name:'Bruce Lee';Score: 7000),
        (Name:'Bill Perl';Score: 6000),
        (Name:'Jackson  ';Score: 5000),
        (Name:'Madonna  ';Score: 4000),
        (Name:'Linda    ';Score: 3000),
        (Name:'Nicholas ';Score: 2000),
        (Name:'Unicorn  ';Score: 1000));
  Var   FDisc  : file of ScoreFType;
        TempScores : ScoreFtype;

  Procedure CreateScoreFile;
  Procedure ChangeScoreFile(CurrentScore:integer);
  Procedure ShowTempScores;

Implementation

  Procedure CreateScoreFile;
  Begin
  {$I-}
    Assign(FDisc,ScoreFName);
    Reset(FDisc);
    if ioresult<>0 then
     begin
      Rewrite(FDisc);
      Write(FDisc,DefaultScores);
      TempScores:=DefaultScores;
     end
    else Read(FDisc,TempScores);
    Close(FDisc);
  {$I+}
  End;

  Procedure ChangeScoreFile(CurrentScore:integer);
  Var ch:char;
      snp,snp1 : string;
      n,n1:byte;

  Begin
    SetFillStyle(1,1);
    Bar(218,180,352,222);
    SetFillStyle(1,9);
    Bar(220,200,350,220);
    SetColor(11);
    OutTextXY(224,186,'Input your name');
    snp:=''; snp1:='..........'; n:=0;
    SetColor(10);
    Repeat
      SetFillStyle(1,9);
      Bar(220,200,350,220);
      OutTextXY(245,209,snp+snp1);
      ch:=Readkey;
      case ch of
       'a'..'z','A'..'Z','0'..'9',' ':
       begin
        if n<10 then
         begin
          snp:=snp+ch;
          dec(byte(snp1[0]));
          inc(n);
         end;
       end;
       #08:
       begin
        if n>0 then
         begin
          dec(byte(snp[0]));
          snp1:=snp1+'.';
          dec(n);
         end;
       end;
      end;
    Until ch=#13;
    n:=1;
    While (TempScores[n].Score>CurrentScore) do inc(n);
    for  n1:=10 downto n do
     begin
      TempScores[n1].Score:=TempScores[n1-1].Score;
      TempScores[n1].Name:=TempScores[n1-1].Name;
     end;
    TempScores[n].Name:=snp;
    TempScores[n].Score:=CurrentScore;
    Assign(FDisc,ScoreFName);
    Rewrite(FDisc);
    Write(FDisc,TempScores);
    Close(FDisc);
  End;

  Procedure ShowTempScores;
  Var n:byte;
      scs:string;
  Begin
    SetFillStyle(1,1);
    Bar(200,180,400,307);
    SetFillStyle(1,9);
    Bar(202,200,398,305);
    SetColor(11);
    OutTextXY(224,186,'High Scores Table');
    SetColor(10);
    for n:=1 to 10 do
     begin
      OutTextXY(226,204+(n-1)*10,TempScores[n].Name);
      Str(TempScores[n].Score : 5 ,Scs);
      OutTextXY(340,204+(n-1)*10,Scs);
     end;
    readkey;
  End;
End.